import controlP5.*;
ControlP5 cp5;

int eyeDistance;
int eyeSize;
boolean heavybrow;
boolean sleepless;
Slider2D s;
int mouthWidth;

void setup() {
    size(720,485);
    cp5 = new ControlP5(this);
    cp5.addTextfield("alias")
        .setPosition(500,20)
        .setSize(200,25)
        ;
    cp5.addSlider("eyeDistance")
        .setPosition(500,80)
        .setSize(200,20)
        .setRange(30,120)
        .setValue(80)
        ;
    cp5.getController("eyeDistance")
        .getCaptionLabel()
        .align(ControlP5.LEFT, ControlP5.BOTTOM_OUTSIDE)
        .setPaddingX(0)
        ;
    
    cp5.addKnob("eyeSize")
        .setPosition(515,135)
        .setRadius(35)
        .setRange(10,60)
        .setValue(50)
        ;

    cp5.addToggle("heavybrow")
        .setPosition(635,138)
        .setSize(20,20)
        ;

    cp5.addToggle("sleepless")
        .setPosition(635,185)
        .setSize(20,20)
        ;
        // nose
    s = cp5.addSlider2D("nosePosition")
        .setPosition(500,240)
        .setSize(200,100)
        .setMinMax(-30,-20,30,20)
        .setValue(0,0)
        ;
    

    cp5.addSlider("mouthWidth")
        .setPosition(500,375)
        .setSize(200,20)
        .setRange(10,200)
        .setValue(124)
        .setNumberOfTickMarks(6)
        .setSliderMode(Slider.FLEXIBLE)
        ;
    
    cp5.getController("mouthWidth")
        .getCaptionLabel()
        .align(ControlP5.LEFT, ControlP5.BOTTOM_OUTSIDE)
        .setPaddingX(0)
        .setPaddingY(12)
        ;
    cp5.addButton("saveImage")
        .setPosition(500,440)
        .setSize(200,25)
        ;
}
  
void draw() {
    background(#004477);
    stroke(#FFFFFF);
    strokeWeight(3);
    int axis = 250;

    // face
    noFill();
    ellipse(axis,220, 370,370);
    // alias
    fill(#FFFFFF);
    textSize(20);
    textAlign(CENTER);
    String alias = cp5.get(Textfield.class,"alias").getText();
    text(alias, axis,450);
    noFill();
    // eyes
    ellipse(axis-eyeDistance,180, eyeSize,eyeSize);
    ellipse(axis+eyeDistance,180, eyeSize,eyeSize);

    if(heavybrow == true){
        fill(#004477); stroke(#004477);
        rect(100,180-eyeSize/2, 300,eyeSize/2);
        stroke(#FFFFFF);
        line(
          axis-eyeDistance-eyeSize/2-5, 180,
          axis+eyeDistance+eyeSize/2+5, 180
        );
    }

    if(sleepless == true){
        noFill();
        arc(axis-eyeDistance,190,
            eyeSize,eyeSize, 0,HALF_PI);
        arc(axis+eyeDistance,190,
            eyeSize,eyeSize, HALF_PI,2.5);
        fill(#004477);
    }
    // nose
    float nosex = s.getArrayValue()[0];
    float nosey = s.getArrayValue()[1];
    line(axis-10+nosex,180+nosey, 
         axis-10+nosex,300+nosey);
    line(axis-10+nosex,300+nosey,
         axis-10+nosex+30,300+nosey);

    // mouth
    line(axis-mouthWidth/2,340, axis+mouthWidth/2,340);
}

void saveImage() {
  save("drawing");
}  
